import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

// event listener using outer class
class ButtonActionListener implements ActionListener {
	JFrame frame = null;
	public ButtonActionListener(JFrame frame) {
		this.frame = frame;
	}
	@Override
	public void actionPerformed(ActionEvent e) {
		frame.setVisible(false);
		frame.dispose();
	}			
}

class SliderChangeListener implements ChangeListener {
	JTextField textfield = null;
	JSlider slider = null;
	public SliderChangeListener(JTextField textfield, JSlider slider) {
		this.textfield = textfield;
		this.slider = slider;
	}
	@Override
	public void stateChanged(ChangeEvent e) {
		textfield.setText("" + slider.getValue());
	}		
}

class TextKeyListener implements KeyListener {
	JTextField textfield = null;
	JSlider slider = null;
	public TextKeyListener(JTextField textfield, JSlider slider) {
		this.textfield = textfield;
		this.slider = slider;
	}
	@Override
	public void keyTyped(KeyEvent e) {	}
	@Override
	public void keyReleased(KeyEvent e) { }
	@Override
	public void keyPressed(KeyEvent e) {
		// TODO Auto-generated method stub
		int key = e.getKeyCode();
		if (key == KeyEvent.VK_ENTER) {
			int value = Integer.parseInt(textfield.getText());
			slider.setValue(value);
		}
	}	
}

public class SliderFrame4 extends JFrame /*implements ActionListener, ChangeListener, KeyListener*/ {
	JPanel panel = new JPanel(new BorderLayout());
	JPanel panel1 = new JPanel(new FlowLayout());
	JSlider slider = new JSlider(JSlider.HORIZONTAL, 0, 100, 20);
	JLabel label = new JLabel("Value: ", JLabel.CENTER);
	JTextField textfield = new JTextField(10);
	JButton button = new JButton("Close");
	
	public SliderFrame4(String name) {
		super(name);
		this.add(panel);
		panel1.add(label);
		panel1.add(textfield);
		panel.add(slider, BorderLayout.CENTER);
		panel.add(panel1, BorderLayout.NORTH);
		panel.add(button, BorderLayout.SOUTH);
		
		//button.addActionListener(new ButtonActionListener(this));
		button.addActionListener(e -> {
			setVisible(false);
			dispose();
		});
		//slider.addChangeListener(new SliderChangeListener(textfield, slider));
		slider.addChangeListener(e -> {
			textfield.setText("" + slider.getValue());			
		});
		textfield.addKeyListener(new TextKeyListener(textfield, slider));
		
		this.setSize(250, 150);
		this.setVisible(true);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}
	
	public static void main(String[] args) {
		new SliderFrame4("slider frame 4");
	}
}
